exercise_06_14: main.o | .gitignore
	g++ $^ -o $@ 

%.ii: %.cpp
	g++ -E $^ -o $@

%.s: %.ii
	g++ -S $^ -o $@

%.o: %.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_06_14" > $@

clean:
	rm *.ii *.s *.o *.out exercise_06_14 .gitignore

test: exercise_06_14
	@./exercise_06_14 > test.out
	@diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: main.ii main.s
.SECONDARY: main.ii main.s

dbg: debug/exercise_06_14 

debug/exercise_06_14: debug/main.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@

debug/main.o: debug/main.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/main.s: debug/main.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/main.ii: main.cpp | debug
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug:
	mkdir -p debug

